var browshot = require('browshot');

var client = new browshot('my_api_key');

var interval;

client.screenshotCreate({url: 'http://mobilio.net/', instance_id: 12 }, function(screenshot) {
	// If the screenshot is already in cache, it could be finished already. Otherwise, wait longer
	if (screenshot.status == 'error') {
		console.log(`Screenshot #${screenshot.id} failed: ${screenshot.error}`);
	}
	else if (screenshot.status == 'finished') {
		screenshotFinished(screenshot);
	}
	else {
		interval = setInterval(checkScreenshot, 1000 * 10, screenshot.id);
	}

});


function checkScreenshot(id) {
	client.screenshotInfo(id, { }, function(screenshot) {
		if (screenshot.status == 'error') {
			clearInterval(interval);
			
			console.log(`Screenshot #${screenshot.id} failed: ${screenshot.error}`);
		}
		else if (screenshot.status == 'finished') {
			clearInterval(interval);
			
			screenshotFinished(screenshot);
		}
		else {
			console.log(`Waiting for screenshot #${screenshot.id} to finish...`);
		}
	});
}

function screenshotFinished(screenshot) {
	// delete URL
	client.screenshotDelete(screenshot.id, { data: 'url' }, function(screenshot) {
		client.screenshotInfo(screenshot.id, { }, function(info) {
			if (! info.hasOwnProperty('url') || info.url == '') {
				console.log(`URL has been deleted for screenshot #${info.id}`);
			}
		});
	});
	
	// delete the image
	client.screenshotDelete(screenshot.id, { data: 'image' }, function(screenshot) {
		client.screenshotThumbnail(screenshot.id, { }, function(image) {
			if (image.length == 0) {
			console.log(`Image has been deleted for screenshot #${screenshot.id}`);
			}
		});
	});
	
	// Delete everything
	client.screenshotDelete(screenshot.id, { data: 'all' }, function(screenshot) {
		console.log("All data have been deleted");
	});
}
